/* 
 * File:   Rover_Command_Final.c
 * Author: John
 *
 * Created on April 6, 2018, 12:33 AM
 */

#include <stdio.h>
#include <stdlib.h>
#include <xc.h>
#include "config.h"
#include "uart_config.h"
#include "lora_config.h"
#include "interrupt_config.h"
#include "setup_devices_file.h"

/*
 * 
 */
int hex_to_int(char c);
int hex_to_ascii(char c, char d);
int character_int[21];
int altitude_int[5];
float ascii2float(int characterArray[]);
void function_that_does_something_with_data(unsigned char data[received_string_length-received_data_offset]) {
    int i = 0;
    float altitude_meter;
    float altitude_feet;
    // do something here:
     character_int[0] = hex_to_ascii(data[0], data[1]);
     character_int[1] = hex_to_ascii(data[2], data[3]);
     character_int[2] = hex_to_ascii(data[4], data[5]);
     character_int[3] = hex_to_ascii(data[6], data[7]);
     character_int[4] = hex_to_ascii(data[8], data[9]);
     character_int[5] = hex_to_ascii(data[10], data[11]);
     character_int[6] = hex_to_ascii(data[12], data[13]);
     character_int[7] = hex_to_ascii(data[14], data[15]);
     character_int[8] = hex_to_ascii(data[16], data[17]);
     character_int[9] = hex_to_ascii(data[18], data[19]);
     character_int[10] = hex_to_ascii(data[20], data[21]);
     character_int[11] = hex_to_ascii(data[22], data[23]);
     character_int[12] = hex_to_ascii(data[24], data[25]);
     character_int[13] = hex_to_ascii(data[26], data[27]);
     character_int[14] = hex_to_ascii(data[28], data[29]);
     character_int[15] = hex_to_ascii(data[30], data[31]);
     character_int[16] = hex_to_ascii(data[32], data[33]);
     character_int[17] = hex_to_ascii(data[34], data[35]);
     character_int[18] = hex_to_ascii(data[36], data[37]);
     character_int[19] = hex_to_ascii(data[38], data[39]);
     character_int[20] = hex_to_ascii(data[40], data[41]);

     altitude_int[0] = hex_to_ascii(data[42], data[43]);
     altitude_int[1] = hex_to_ascii(data[44], data[45]);
     altitude_int[2] = hex_to_ascii(data[46], data[47]);
     altitude_int[3] = hex_to_ascii(data[48], data[49]);
     altitude_int[4] = '\0';
     
//    for (i = 0; i < sizeof(character_int)/sizeof(int); i++){
//        printArray[i] = (char)character_int[i];
//    }
    printf("\n\rReceived data: ");
    for (i = 0; i < sizeof(character_int)/sizeof(int);i++) {
        printf("%c", character_int[i]);
    }
    printf("\n\r Current Altitude above sea level ");
    for (i = 0; i < (sizeof(altitude_int)/sizeof(int)-1);i++) {
        printf("%c", altitude_int[i]);
    }
    printf(" meters\n\r");
    
     //
}

int main(int argc, char** argv) {
//    configure_uart();
    setup_devices();
//	configure_interrupts();
//    LORA_nRESET = low;
//    delay_ms(100);
//    LORA_nRESET = high;    
//     while (true)
//     {
//        
//        LoRa();
//     }
    while(1){
        LATFbits.LATF5 = !LATFbits.LATF5;
    }
 return (EXIT_SUCCESS);
}

int hex_to_int(char c){
        int first = c / 16 - 3;
        int second = c % 16;
        int result = first*10 + second;
        if(result > 9) result--;
        return result;
}

int hex_to_ascii(char c, char d){
        int MSB = hex_to_int(c) * 16;
        int LSB = hex_to_int(d);
        return MSB + LSB;
}

